// get OperationContextScope (see WCF documentation)
using (System.ServiceModel.OperationContextScope ocs =
    new System.ServiceModel.OperationContextScope((queryService.InnerChannel))) {

    // instantiate and initialize CallContext (using class from other service)
    CustomerService.CallContext callContext = new CustomerService.CallContext();
    callContext.Company = "CEU";

	// explicitly add header "CallContext" to set of outgoing headers
    System.ServiceModel.Channels.MessageHeaders messageHeadersElement =
    System.ServiceModel.OperationContext.Current.OutgoingMessageHeaders;
    messageHeadersElement.Add(
        System.ServiceModel.Channels.MessageHeader.CreateHeader(
        "CallContext",
        "http://schemas.microsoft.com/dynamics/2010/01/datacontracts",
        callContext));

	// initialize paging (return 3 records or less)
	QueryService.Paging paging = new QueryService.ValueBasedPaging();
	((QueryService.ValueBasedPaging)paging).RecordLimit = 3;

	// instantiate a service proxy
	QueryService.QueryServiceClient queryService = new QueryService.QueryServiceClient();

	// consume query service using CallContext
	System.Data.DataSet ds = queryService.ExecuteStaticQuery("MyQuery", ref paging);
}