static TTargetContract ConvertContract<TSourceContract, TTargetContract>
    (TSourceContract sourceContract)
        where TSourceContract : class
        where TTargetContract : class
{
    TTargetContract targetContract = default(TTargetContract);
    var sourceSerializer = new DataContractSerializer(typeof(TSourceContract));
    var targetSerializer = new DataContractSerializer(typeof(TTargetContract));
    using (var stream = new MemoryStream())
    {
        sourceSerializer.WriteObject(stream, sourceContract);
        stream.Position = 0;
        targetContract = (TTargetContract)targetSerializer.ReadObject(stream);
    }
    return targetContract;
}